import java.io.*;
import java.sql.*;
import java.text.*;

public class TestDataTypes {
 Connection conn;
 public TestDataTypes() {
  try {
   DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
   conn = DriverManager.getConnection(
    "jdbc:oracle:thin:@dssw2k01:1521:orcl", "scott", "tiger");
  }
  catch (SQLException e) {
   System.err.println(e.getMessage());
   e.printStackTrace();
  }
 }

 public static void main(String[] args) 
  throws Exception, IOException {
  new TestDataTypes().process();
 }

 public void process() throws IOException, SQLException {
  int               rows = 0;
  ResultSet         rslt = null;
  ResultSetMetaData meta = null;
  Statement         stmt = null;
  try {
   stmt = conn.createStatement();
//   rslt = stmt.executeQuery("select 12345678901234567890123456789012345678, 1234567890.1234567890123456789012345678, to_char(sysdate), sysdate from sys.dual");
   rslt = stmt.executeQuery(
    "select a_big_integer, an_integer, a_big_float, a_float, " + 
    "a_varchar2, a_char, a_date, a_long from test_data_types");
   meta = rslt.getMetaData();
/*
   System.out.println("a_big_integer = " + formatDataType(meta.getColumnType(1)));
   System.out.println("an_integer    = " + formatDataType(meta.getColumnType(2)));
   System.out.println("a_big_float   = " + formatDataType(meta.getColumnType(3)));
   System.out.println("a_float       = " + formatDataType(meta.getColumnType(4)));
   System.out.println("a_varchar2    = " + formatDataType(meta.getColumnType(5)));
   System.out.println("a_char        = " + formatDataType(meta.getColumnType(6)));
   System.out.println("a_date        = " + formatDataType(meta.getColumnType(7)));
   System.out.println("a_long        = " + formatDataType(meta.getColumnType(8)));
*/
   for (int i=1;i <= meta.getColumnCount();i++) {
    System.out.println(meta.getColumnName(i) + ":");
    System.out.println("Label        = " + meta.getColumnLabel(i));
    System.out.println("Class Name   = " + meta.getColumnClassName(i));
    System.out.println("DB Type Name = " + meta.getColumnTypeName(i));
    System.out.println("Types Name   = " + formatDataType(meta.getColumnType(i)));
    System.out.println(" ");
   }
   while (rslt.next()) {
    rows++;
   }
  }
  catch (SQLException e) {
   System.err.println(e.getMessage());
  }
  finally {
   if (rslt != null) try { rslt.close(); } catch (SQLException ignore) { }
   if (stmt != null) try { stmt.close(); } catch (SQLException ignore) { }
  }
 }

 private String formatDataType(int Type) {
  switch (Type) {
   case Types.ARRAY: 
      return "ARRAY";
   case Types.BIGINT: 
      return "BIGINT";
   case Types.BINARY: 
      return "BINARY";
   case Types.BIT: 
      return "BIT";
   case Types.BLOB: 
      return "BLOB";
   case Types.CHAR: 
      return "CHAR";
   case Types.CLOB: 
      return "CLOB";
   case Types.DATE: 
      return "DATE";
   case Types.DECIMAL: 
      return "DECIMAL";
   case Types.DISTINCT: 
      return "DISTINCT";
   case Types.DOUBLE: 
      return "DOUBLE";
   case Types.FLOAT: 
      return "FLOAT";
   case Types.INTEGER: 
      return "INTEGER";
   case Types.JAVA_OBJECT: 
      return "JAVA_OBJECT";
   case Types.LONGVARBINARY: 
      return "LONGVARBINARY";
   case Types.LONGVARCHAR: 
      return "LONGVARCHAR";
   case Types.NULL: 
      return "NULL";
   case Types.NUMERIC: 
      return "NUMERIC";
   case Types.OTHER: 
      return "OTHER";
   case Types.REAL: 
      return "REAL";
   case Types.REF: 
      return "REF";
   case Types.SMALLINT: 
      return "SMALLINT";
   case Types.STRUCT: 
      return "STRUCT";
   case Types.TIME: 
      return "TIME";
   case Types.TIMESTAMP: 
      return "TIMESTAMP";
   case Types.TINYINT: 
      return "TINYINT";
   case Types.VARBINARY: 
      return "VARBINARY";
   case Types.VARCHAR: 
      return "VARCHAR";
   default:
      return "UNKNOWN";
  }
 }

 protected void finalize() 
  throws Throwable {
  if (conn != null) { try { conn.close(); } catch (SQLException ignore) { } }
  super.finalize();
 }
}