import java.sql.SQLException;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.driver.OracleTypes;
import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;

public class JLocation implements SQLData
{
  public static final String _SQL_NAME = "SCOTT.LOCATION_TYP";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  private java.math.BigDecimal m_locationId;
  private java.math.BigDecimal m_parentLocationId;
  private String m_code;
  private String m_name;
  private java.sql.Timestamp m_startDate;
  private java.sql.Timestamp m_endDate;

  /* constructor */
  public JLocation()
  {
  }

  public void readSQL(SQLInput stream, String type)
  throws SQLException
  {
      setLocationId(stream.readBigDecimal());
      setParentLocationId(stream.readBigDecimal());
      setCode(stream.readString());
      setName(stream.readString());
      setStartDate(stream.readTimestamp());
      setEndDate(stream.readTimestamp());
  }

  public void writeSQL(SQLOutput stream)
  throws SQLException
  {
      stream.writeBigDecimal(getLocationId());
      stream.writeBigDecimal(getParentLocationId());
      stream.writeString(getCode());
      stream.writeString(getName());
      stream.writeTimestamp(getStartDate());
      stream.writeTimestamp(getEndDate());
  }

  public String getSQLTypeName() throws SQLException
  {
    return _SQL_NAME;
  }

  /* accessor methods */
  public java.math.BigDecimal getLocationId()
  { return m_locationId; }

  public void setLocationId(java.math.BigDecimal locationId)
  { m_locationId = locationId; }


  public java.math.BigDecimal getParentLocationId()
  { return m_parentLocationId; }

  public void setParentLocationId(java.math.BigDecimal parentLocationId)
  { m_parentLocationId = parentLocationId; }


  public String getCode()
  { return m_code; }

  public void setCode(String code)
  { m_code = code; }


  public String getName()
  { return m_name; }

  public void setName(String name)
  { m_name = name; }


  public java.sql.Timestamp getStartDate()
  { return m_startDate; }

  public void setStartDate(java.sql.Timestamp startDate)
  { m_startDate = startDate; }


  public java.sql.Timestamp getEndDate()
  { return m_endDate; }

  public void setEndDate(java.sql.Timestamp endDate)
  { m_endDate = endDate; }

}
